unit disptest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    msdelay,delz: int64;
    procedure delay(ms: integer);
    procedure WriteData(d: byte);
    procedure WriteCTRL(d: byte);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var t: TDateTime;
begin
  t:=now+(1/86400);
  msdelay:=0;
  delz:=$7FFFFFFFFFFFFFFF;
  while (now<t) AND (msdelay<delz) do
    inc(msdelay);
  msdelay:=msdelay div 1000;
end;

procedure TForm1.Delay(ms: integer);
var t: TDateTime;
    z: integer;
begin
  t:=now+(5/86400);
  for z:=1 to ms do begin
    delz:=0;
    while (now<t) AND (delz<msdelay) do
      inc(msdelay);
  end;
end;

procedure PortWR(p:word; data: BYTE);
(* Auf Printer-Datenport d ausgeben *)
var bs: word;
begin
  bs:=p;;
  asm
    mov dx,bs
    mov al,data
    out dx,al
  end;
end;

procedure TForm1.WriteData(d: byte);
begin
  Delay(1);
  PortWR($378,d);
  portwr($378+2,0); (* C/D = L (Data) *)
  portwr($378+2,2); (* CE *)
  portwr($378+2,3); (* CE+WR *)
  portwr($378+2,2); (* CE *)
  portwr($378+2,0);
end;
procedure TForm1.WriteCtrl(d: byte);
begin
  Delay(1);
  PortWR($378,d);
  portwr($378+2,4); (* C/D = H (ctrl) *)
  portwr($378+2,4+2); (* CE *)
  portwr($378+2,4+3); (* CE+WR *)
  portwr($378+2,4+2); (* CE *)
  portwr($378+2,0);
end;

end.
